#include "stdlib.h"
#include "SDL/SDL.h"

int main(int argc, char *argv[])
{
	SDL_Surface *screen;
	SDL_Surface *image;
	SDL_Surface *temp;
	SDL_Rect src, dest;

	//We must first initialise the SDL video component, and check for success
	if (SDL_Init(SDL_INIT_VIDEO) != 0) {
		printf("Unable to initialize SDL: %s\n", SDL_GetError());
		return 1;
	}

	atexit(SDL_Quit);

	//Set the video mode to fullscreen 8000x480 with 16bit colour and double-buffering
	screen = SDL_SetVideoMode(800, 480, 16, SDL_DOUBLEBUF | SDL_FULLSCREEN);
	if (screen == NULL) {
		printf("Unable to set video mode: %s\n", SDL_GetError());
		return 1;
	}

	//Load the bitmap into a temporary surface, and check for success
	temp = SDL_LoadBMP("test.bmp");
	if (temp == NULL) {
		printf("Unable to load bitmap: %s\n", SDL_GetError());
		return 1;
	}

	//Convert the surface to the appropriate display format
	image = SDL_DisplayFormat(temp);

	//Release the temporary surface
	SDL_FreeSurface(temp);

	//Construct the source rectangle for our blit
	src.x = 0;
	src.y = 0;
	src.w = image->w;
	src.h = image->h;

	//Construct the destination rectangle for our blit
	dest.x = 0;
	dest.y = 0;
	dest.w = image->w;
	dest.h = image->h;

	//Blit the image to the backbuffer
	SDL_BlitSurface(image, &src, screen, &dest);

	//Flip the backbuffer to the primary
	SDL_Flip(screen);

	//Wait for 10000ms (10 seconds) so we can see the image
	SDL_Delay(10000);

	//Release the surface
	SDL_FreeSurface(image);

	//Return success!
	return 0;
}
